NPMIP_a_Parameters = [
	["MenuWidth",          150,		"number"],
	["FontFamily",         null],
	["FontSize",           10,		"number"],
	["FontBold",           false,	"boolean"],
	["FontItalic",         false,	"boolean"],
	["FontColor",          "black"],
	["FontColorOver",      "white"],
	["BGColor",            "white"],
	["BGColorOver",        "black"],
	["ItemPadding",        3,		"number"],
	["BorderWidth",        2,		"number"],
	["BorderColor",        "red"],
	["BorderStyle",        "solid"],
	["SeparatorSize",      1,		"number"],
	["SeparatorColor",     "yellow"],
	["ImageSrc",           null],
	["ImageSrcOver",       null],
	["ImageSrcLeft",       null],
	["ImageSrcLeftOver",   null],
	["ImageSize",          5,		"number"],
	["ImageHorizSpace",    0,		"number"],
	["ImageVertSpace",     0,		"number"],
	["KeepHilite",         false,	"boolean"],
	["ClickStart",         false,	"boolean"],
	["ClickKill",          true,	"boolean"],
	["ChildOverlap",       20,		"number"],
	["ChildOffset",        10,		"number"],
	["ChildPerCentOver",   null,	"number"],
	["TopSecondsVisible",  .5,		"number"],
	["ChildSecondsVisible",.3,		"number"],
	["StatusDisplayBuild", 1,		"boolean"],
	["StatusDisplayLink",  1,		"boolean"],
	["UponDisplay",        null,	"delayed"],
	["UponHide",           null,	"delayed"],
	["RightToLeft",        false,	"boolean"],
	["CreateTopOnly",      0,		"boolean"],
	["ShowLinkCursor",     false,	"boolean"]
]

NPMIP_MenuIDPrefix = "NPMIP_Menu";
NPMIP_ItemIDPrefix = "NPMIP_Item";
NPMIP_ArrayIDPrefix = "NPMIP_Array";
NPMIP_Link = null;

Function.prototype.isFunction = true;
Function.prototype.isString = false;
String.prototype.isFunction = false;
String.prototype.isString = true;
String.prototype.isBoolean = false;
String.prototype.isNumber = false;
Number.prototype.isString = false;
Number.prototype.isFunction = false;
Number.prototype.isBoolean = false;
Number.prototype.isNumber = true;
Boolean.prototype.isString = false;
Boolean.prototype.isFunction = false;
Boolean.prototype.isBoolean = true;
Boolean.prototype.isNumber = false;
Array.prototype.itemValidation = false;
Array.prototype.isArray = true;

function NPMIP_f_AssignParameters(paramarray){
	var ParamName = paramarray[0];
	var DefaultValue = paramarray[1];
	var FullParamName = "NPMIP_" + ParamName;

	if (typeof eval("window.NPMIP_PG_" + ParamName) == "undefined") {
		if (typeof eval("window.NPMIP_GL_" + ParamName) == "undefined") {
			eval(FullParamName + "= DefaultValue");
		}
		else {
			eval(FullParamName + "= NPMIP_GL_" + ParamName);
		}
	}
	else {
		eval(FullParamName + "= NPMIP_PG_" + ParamName);
	}

	paramarray[0] = FullParamName;
	paramarray[1] = eval(FullParamName);
}

function NPMIP_f_EvalParameters(valuenew,valueold,valuetype){
	var TestString, ParPosition;

	if(typeof valuenew == "undefined" || valuenew == null || (valuenew.isString && valuenew.length == 0)){
		return valueold;
	}

	if(valuetype != "delayed"){
		while(valuenew.isString) {
			ParPosition = valuenew.indexOf("(");
			if(ParPosition !=-1) {
				TestString = "window." + valuenew.substr(0,ParPosition);
				if (typeof eval(TestString) != "undefined" && eval(TestString).isFunction) {
					valuenew = eval(valuenew);
				}
			}
			else break
		}
	}

	while(valuenew.isFunction) {valuenew = valuenew()}

	switch(valuetype){	
		case "number":
			while (valuenew.isString) {valuenew = eval(valuenew)}
			break;
		case "boolean":
			while (!valuenew.isBoolean) {
				valuenew = (valuenew.isNumber) ? valuenew ? true : false : eval(valuenew);
			}
			break;
	}

	return valuenew;
}

for (i=0;i<NPMIP_a_Parameters.length;i++) {
	NPMIP_f_AssignParameters(NPMIP_a_Parameters[i]);
	eval(NPMIP_a_Parameters[i][0] + "= NPMIP_f_EvalParameters("+ NPMIP_a_Parameters[i][0] +",null,NPMIP_a_Parameters[i][2])")
}

NPMIP_ChildPerCentOver = (isNaN(parseFloat(NPMIP_ChildPerCentOver))) ? null : parseFloat(NPMIP_ChildPerCentOver)/100;

NPMIP_ChildMilliSecondsVisible = NPMIP_ChildSecondsVisible * 1000;

function NPMIP_f_ValidateArray(arrayname){
	var MenuArrayIsValid = false;
	var MenuArrayIsObject = (typeof eval("window." + arrayname) == "object");
	if(MenuArrayIsObject) { 
		var TheMenuArray = eval(arrayname);
		if(TheMenuArray.isArray && TheMenuArray.length > 1) {
			MenuArrayIsValid = true;
			if(!TheMenuArray.itemValidation) {
				while((typeof TheMenuArray[TheMenuArray.length-1] != "object") || (!TheMenuArray[TheMenuArray.length-1].isArray)) {
					TheMenuArray.length--;
				}
				TheMenuArray.itemValidation = true;
			}
		}
	}
	return MenuArrayIsValid;
}

if(!window.NPMIP_a_TreesToBuild) {
	NPMIP_a_TreesToBuild = [];
	for(i=1; i<NPMIP_a_NumTreesToBuild; i++){
		if(NPMIP_f_ValidateArray(NPMIP_ArrayIDPrefix + i)) NPMIP_a_TreesToBuild[NPMIP_a_TreesToBuild.length] = i;
	}
}

NPMIP_CurrentArray = null;
NPMIP_CurrentTree  = null;
NPMIP_CurrentMenu  = null;
NPMIP_CurrentItem  = null;
NPMIP_a_TopMenus = [];
NPMIP_AreLoaded = false;
NPMIP_AreCreated = false;
NPMIP_BeingCreated = false;
NPMIP_UserOverMenu = false;
NPMIP_HideAllTimer = null;
NPMIP_TotalTrees = 0; 
NPMIP_ZIndex = 5000;

function propertyTransfer(){
	this.obj = eval(this.id + "Obj");
	for (temp in this.obj) {this[temp] = this.obj[temp]}
}

function NPMIP_f_StartIt() {
	if((typeof(document.body) == "undefined") || (document.body == null)) return;
	if(NPMIP_AreCreated) return;
	NPMIP_AreLoaded = true;
	if (NPMIP_ClickKill) {
		NPMIP_f_OtherMouseDown = (document.onmousedown) ? document.onmousedown : new Function;
    	document.onmousedown = function(){NPMIP_f_PageClick();NPMIP_f_OtherMouseDown()}
    }
	else {
		NPMIP_TopMilliSecondsVisible = NPMIP_TopSecondsVisible * 1000;
	}
    NPMIP_f_MakeTrees();
	NPMIP_f_OtherOnLoad();
}

function NPMIP_f_MakeTrees(){
    NPMIP_BeingCreated = true;
	var TreeParams = null;
	var TreeHasChildren = false;
	var ItemArray = null;

	for(var t=0; t<NPMIP_a_TreesToBuild.length; t++) {
		if(!NPMIP_f_ValidateArray(NPMIP_ArrayIDPrefix + NPMIP_a_TreesToBuild[t])) continue;
		NPMIP_CurrentArray = eval(NPMIP_ArrayIDPrefix + NPMIP_a_TreesToBuild[t]);

		TreeParams = NPMIP_CurrentArray[0];
		TreeHasChildren = false;

		for(var i=1; i<NPMIP_CurrentArray.length; i++) {
			ItemArray = NPMIP_CurrentArray[i];
			if(ItemArray[ItemArray.length-1]) {TreeHasChildren = true; break}
		}

		NPMIP_CurrentTree = {
			MenuWidth        : MenuWidth = NPMIP_f_EvalParameters(TreeParams[0],NPMIP_MenuWidth,"number"),
			MenuLeft         : MenuLeft = NPMIP_f_EvalParameters(TreeParams[1],null,"delayed"),
			MenuTop          : MenuTop = NPMIP_f_EvalParameters(TreeParams[2],null,"delayed"),
			ItemWidth        : MenuWidth - (NPMIP_BorderWidth*2),
			FontColor        : NPMIP_f_EvalParameters(TreeParams[3],NPMIP_FontColor),
			FontColorOver    : NPMIP_f_EvalParameters(TreeParams[4],NPMIP_FontColorOver),
			BGColor          : NPMIP_f_EvalParameters(TreeParams[5],NPMIP_BGColor),
			BGColorOver      : NPMIP_f_EvalParameters(TreeParams[6],NPMIP_BGColorOver),
			BorderColor      : NPMIP_f_EvalParameters(TreeParams[7],NPMIP_BorderColor),
			SeparatorColor   : NPMIP_f_EvalParameters(TreeParams[8],NPMIP_SeparatorColor),
			TopIsPermanent   : ((MenuLeft == null) || (MenuTop == null)) ? false : NPMIP_f_EvalParameters(TreeParams[9],false,"boolean"),
			TopIsHorizontal  : TopIsHorizontal = NPMIP_f_EvalParameters(TreeParams[10],false,"boolean"),
			TreeIsHorizontal : TreeHasChildren ? NPMIP_f_EvalParameters(TreeParams[11],false,"boolean") : false,
			PositionUnder    : (!TopIsHorizontal || !TreeHasChildren) ? false : NPMIP_f_EvalParameters(TreeParams[12],false,"boolean"),
			TopImageShow     : TreeHasChildren ? NPMIP_f_EvalParameters(TreeParams[13],true,"boolean")  : false,
			TreeImageShow    : TreeHasChildren ? NPMIP_f_EvalParameters(TreeParams[14],true,"boolean")  : false,
			UponDisplay      : NPMIP_f_EvalParameters(TreeParams[15],NPMIP_UponDisplay,"delayed"),
			UponHide         : NPMIP_f_EvalParameters(TreeParams[16],NPMIP_UponHide,"delayed"),
			RightToLeft      : NPMIP_f_EvalParameters(TreeParams[17],NPMIP_RightToLeft,"boolean"),
			ClickStart		 : NPMIP_f_EvalParameters(TreeParams[18],NPMIP_ClickStart,"boolean"),
			TopIsVariableWidth  : NPMIP_f_EvalParameters(TreeParams[19],false,"boolean"),
			TreeIsVariableWidth  : NPMIP_f_EvalParameters(TreeParams[20],false,"boolean")
		}

		NPMIP_CurrentMenu = null;
		NPMIP_f_MakeMenu(NPMIP_a_TreesToBuild[t]);
		NPMIP_a_TopMenus[NPMIP_TotalTrees] = NPMIP_CurrentTree.treeParent;
		NPMIP_TotalTrees++;
		if(NPMIP_CurrentTree.TopIsPermanent){
			with(NPMIP_CurrentTree.treeParent) {
				NPMIP_CurrentTree.treeParent.xPos = eval(NPMIP_CurrentTree.MenuLeft);
				NPMIP_CurrentTree.treeParent.yPos = eval(NPMIP_CurrentTree.MenuTop);
				moveTo(NPMIP_CurrentTree.treeParent.xPos,NPMIP_CurrentTree.treeParent.yPos);
				style.zIndex = NPMIP_ZIndex;
				setTimeout(NPMIP_CurrentTree.treeParent.id + ".fixSize(true)",10);
			}
		}
    }

	//if(NPMIP_StatusDisplayBuild) status = NPMIP_TotalTrees + " Hierarchical Menu Trees Created";
	if(NPMIP_StatusDisplayBuild) status = "SysPoint"
    NPMIP_AreCreated = true;
    NPMIP_BeingCreated = false;
}

function NPMIP_f_GetItemDivStr(itemid,disptext,hasmore){
	var WidthValue = NPMIP_CurrentMenu.isHorizontal ? (ItemElement.isLastItem) ? (NPMIP_CurrentTree.MenuWidth - NPMIP_BorderWidth - NPMIP_SeparatorSize) : (NPMIP_CurrentTree.MenuWidth - NPMIP_BorderWidth) : NPMIP_CurrentTree.ItemWidth;
	var TempString = "<DIV ID=" + itemid + " STYLE='position:absolute;width:" + WidthValue + "px'>";
	if(NPMIP_CurrentMenu.showImage) {
		var FullPadding  = (NPMIP_ItemPadding*2) + NPMIP_ImageSize + NPMIP_ImageHorizSpace;
	}
    if(hasmore && NPMIP_CurrentMenu.showImage) {
		var ImgSrc      = NPMIP_CurrentTree.RightToLeft ? NPMIP_ImageSrcLeft : NPMIP_ImageSrc;
		var ImgStyle    = "top:"+ (NPMIP_ItemPadding + NPMIP_ImageVertSpace) + "px;width:"+ NPMIP_ImageSize + "px;";
		var ImgString   = "<IMG ID='NPMIP_ImMore' STYLE='position:absolute;"+ ImgStyle +"' SRC='" + ImgSrc + "' HSPACE=0 VSPACE=0 BORDER=0>";
		TempString += ImgString;
	}
	TempString += disptext + "</DIV>";
	return TempString;
}

function NPMIP_f_SetItemProperties(itemid,itemidsuffix) {
	this.tree        = NPMIP_CurrentTree;
	this.itemsetup   = NPMIP_f_ItemSetup;
	this.index       = NPMIP_CurrentMenu.itemCount - 1;
	this.isLastItem  = (NPMIP_CurrentMenu.itemCount == NPMIP_CurrentMenu.maxItems);
	this.array		 = NPMIP_CurrentMenu.array[NPMIP_CurrentMenu.itemCount];
	this.dispText    = this.array[0];
	this.linkText    = this.array[1];
	this.permHilite  = NPMIP_f_EvalParameters(this.array[3],false,"boolean");
	this.hasRollover = (!this.permHilite && NPMIP_f_EvalParameters(this.array[2],true,"boolean"));
	this.hasMore	 = NPMIP_f_EvalParameters(this.array[4],false,"boolean") && NPMIP_f_ValidateArray(NPMIP_ArrayIDPrefix + itemidsuffix);
	this.childID	 = this.hasMore ? (NPMIP_MenuIDPrefix + itemidsuffix) : null;
	this.child		 = null;
    this.onmouseover = NPMIP_f_ItemOver;
    this.onmouseout  = NPMIP_f_ItemOut;
	this.setItemStyle = NPMIP_f_SetItemStyle;
	this.itemStr	 = NPMIP_f_GetItemDivStr(itemid,this.dispText,this.hasMore);
	this.showChild   = NPMIP_f_ShowChild;
	this.ChildOverlap = null;
}

function NPMIP_f_Make4ItemElement(menucount) {
	var ItemIDSuffix = menucount + "_" + NPMIP_CurrentMenu.itemCount;
	var LayerID  = NPMIP_ItemIDPrefix + ItemIDSuffix;
	var ObjectID = LayerID + "Obj";
	eval(ObjectID + " = new Object()");
	ItemElement = eval(ObjectID);
	ItemElement.setItemProperties = NPMIP_f_SetItemProperties;
	ItemElement.setItemProperties(LayerID,ItemIDSuffix);
	return ItemElement;
}

function NPMIP_f_MakeElement(menuid) {
	var MenuObject;
	var LayerID  = menuid;
	var ObjectID = LayerID + "Obj";
	eval(ObjectID + " = new Object()"); 
	MenuObject = eval(ObjectID);
	return MenuObject;
}

function NPMIP_f_MakeMenu(menucount) {
	if(!NPMIP_f_ValidateArray(NPMIP_ArrayIDPrefix + menucount)) return false;
	NPMIP_CurrentArray = eval(NPMIP_ArrayIDPrefix + menucount);
	NewMenu = document.all(NPMIP_MenuIDPrefix + menucount);
	if(!NewMenu) {
		NewMenu = NPMIP_f_MakeElement(NPMIP_MenuIDPrefix + menucount);
		NewMenu.array = NPMIP_CurrentArray;
		NewMenu.tree  = NPMIP_CurrentTree;

		if(NPMIP_CurrentMenu) {
			NewMenu.parentMenu = NPMIP_CurrentMenu;
			NewMenu.parentItem = NPMIP_CurrentMenu.itemElement;
			NewMenu.parentItem.child = NewMenu;
			NewMenu.hasParent = true;
			NewMenu.isHorizontal = NPMIP_CurrentTree.TreeIsHorizontal;
			NewMenu.showImage = NPMIP_CurrentTree.TreeImageShow;
		}
		else {
			NewMenu.isHorizontal = NPMIP_CurrentTree.TopIsHorizontal;
			NewMenu.showImage = NPMIP_CurrentTree.TopImageShow;
		}
	
		NPMIP_CurrentMenu = NewMenu;
		NPMIP_CurrentMenu.itemCount = 0;
		NPMIP_CurrentMenu.maxItems = NPMIP_CurrentMenu.array.length - 1;
		NPMIP_CurrentMenu.showIt = NPMIP_f_ShowIt;
		NPMIP_CurrentMenu.keepInWindow = NPMIP_f_KeepInWindow;
	    NPMIP_CurrentMenu.onmouseover = NPMIP_f_MenuOver;
	    NPMIP_CurrentMenu.onmouseout = NPMIP_f_MenuOut;
	    NPMIP_CurrentMenu.hideTree = NPMIP_f_HideTree
	    NPMIP_CurrentMenu.hideParents = NPMIP_f_HideParents;
	    NPMIP_CurrentMenu.hideChildren = NPMIP_f_HideChildren;
	    NPMIP_CurrentMenu.hideTop = NPMIP_f_HideTop;
	    NPMIP_CurrentMenu.hideSelf = NPMIP_f_HideSelf;
		NPMIP_CurrentMenu.count = menucount;
	    NPMIP_CurrentMenu.hasChildVisible = false;
	    NPMIP_CurrentMenu.isOn = false;
	    NPMIP_CurrentMenu.hideTimer = null;
	    NPMIP_CurrentMenu.currentItem = null;
		NPMIP_CurrentMenu.setMenuStyle = NPMIP_f_SetMenuStyle;
		NPMIP_CurrentMenu.sizeFixed = false;
		NPMIP_CurrentMenu.fixSize = NPMIP_f_FixSize;
		NPMIP_CurrentMenu.onselectstart = NPMIP_f_CancelSelect;
    	NPMIP_CurrentMenu.moveTo = NPMIP_f_MoveTo;
		NPMIP_CurrentMenu.IsVariableWidth = ((NPMIP_CurrentMenu.hasParent && NPMIP_CurrentTree.TreeIsVariableWidth) || (!NPMIP_CurrentMenu.hasParent && NPMIP_CurrentTree.TopIsVariableWidth));
		NPMIP_CurrentMenu.htmlString = "<DIV ID='" + NPMIP_MenuIDPrefix + menucount +"' STYLE='position:absolute;visibility:hidden;width:"+ NPMIP_CurrentTree.MenuWidth +"'>";
	}

	while (NPMIP_CurrentMenu.itemCount < NPMIP_CurrentMenu.maxItems) {
		NPMIP_CurrentMenu.itemCount++;

		NPMIP_CurrentItem = document.all(NPMIP_ItemIDPrefix + menucount + "_" + NPMIP_CurrentMenu.itemCount);
		if(!NPMIP_CurrentItem) {
			//if(NPMIP_StatusDisplayBuild) status = "Creating Hierarchical Menus: " + menucount + " / " + NPMIP_CurrentMenu.itemCount;
			NPMIP_CurrentMenu.itemElement = NPMIP_f_Make4ItemElement(menucount);
			NPMIP_CurrentMenu.htmlString += NPMIP_CurrentMenu.itemElement.itemStr;
		}
		if(NPMIP_CurrentMenu.itemElement.hasMore && (!NPMIP_CreateTopOnly || NPMIP_AreCreated && NPMIP_CreateTopOnly)) {
	        MenuCreated = NPMIP_f_MakeMenu(menucount + "_" + NPMIP_CurrentMenu.itemCount);
            if(MenuCreated) {
				NPMIP_CurrentMenu = NPMIP_CurrentMenu.parentMenu;
			}
        }
    }

	document.body.insertAdjacentHTML("BeforeEnd",NPMIP_CurrentMenu.htmlString + "</DIV>");
	menuLyr = document.all(NPMIP_MenuIDPrefix + menucount);
	menuLyr.propertyTransfer = propertyTransfer;
	menuLyr.propertyTransfer();
	NPMIP_CurrentMenu = menuLyr;
	if(!NPMIP_CurrentMenu.hasParent)NPMIP_CurrentTree.treeParent = NPMIP_CurrentTree.startChild = NPMIP_CurrentMenu;
	NPMIP_CurrentMenu.setMenuStyle();
    NPMIP_CurrentMenu.items = NPMIP_CurrentMenu.children;
	NPMIP_CurrentMenu.lastItem = NPMIP_CurrentMenu.items[NPMIP_CurrentMenu.items.length-1];
    for(var i=0; i<NPMIP_CurrentMenu.items.length; i++) {
        it = NPMIP_CurrentMenu.items[i];
		it.siblingBelow = i>0 ? NPMIP_CurrentMenu.items[i-1] : null;
		it.propertyTransfer = propertyTransfer;
		it.propertyTransfer();
		it.itemsetup(i+1);
	}
	NPMIP_CurrentMenu.moveTo(0,0);
	return NPMIP_CurrentMenu;
}

function NPMIP_f_SetMenuStyle(){
	with(this.style) {
		borderWidth = NPMIP_BorderWidth + "px";
		borderColor = NPMIP_CurrentTree.BorderColor;
		borderStyle = NPMIP_BorderStyle;
		overflow    = "hidden";
		cursor      = "default";
	}
}

function NPMIP_f_SetItemStyle() {
	with(this.style){
		backgroundColor = (this.permHilite) ? NPMIP_CurrentTree.BGColorOver : NPMIP_CurrentTree.BGColor;
		color		= (this.permHilite) ? NPMIP_CurrentTree.FontColorOver : NPMIP_CurrentTree.FontColor;
		font		= ((NPMIP_FontBold) ? "bold " : "normal ") + NPMIP_FontSize + "pt " + NPMIP_FontFamily;
		padding		= NPMIP_ItemPadding + "px";
		fontStyle	= (NPMIP_FontItalic) ? "italic" : "normal";
		overflow	= "hidden";
		pixelWidth	= NPMIP_CurrentTree.ItemWidth;

		if((this.menu.showImage && (!this.menu.IsVariableWidth || (this.menu.IsVariableWidth && this.tree.RightToLeft && !this.menu.isHorizontal))) || (this.menu.IsVariableWidth && this.imgLyr)) {

			var FullPadding  = (NPMIP_ItemPadding*2) + NPMIP_ImageSize + NPMIP_ImageHorizSpace;
			if (this.tree.RightToLeft) paddingLeft = FullPadding + "px";
			else paddingRight = FullPadding + "px";
		}
		if(!this.isLastItem) {
			var SeparatorString = NPMIP_SeparatorSize + "px solid " + this.tree.SeparatorColor;
			if (this.menu.isHorizontal) borderRight = SeparatorString;
			else borderBottom = SeparatorString;
		}

		if(this.menu.isHorizontal){
			pixelTop = 0;
			if(this.menu.IsVariableWidth) {
				this.realWidth = this.scrollWidth;
				if(this.isLastItem) pixelWidth = this.realWidth;
				else pixelWidth = (this.realWidth + NPMIP_SeparatorSize);
				pixelLeft = this.index ? (this.siblingBelow.style.pixelLeft + this.siblingBelow.style.pixelWidth) : 0;
				if(this.isLastItem) {
					LeftAndWidth = pixelLeft + pixelWidth;
					this.menu.style.pixelWidth = LeftAndWidth + (NPMIP_BorderWidth * 2);
				}

			}
			else {
				if(this.isLastItem) pixelWidth = (NPMIP_CurrentTree.MenuWidth - NPMIP_BorderWidth - NPMIP_SeparatorSize);
				else pixelWidth = (NPMIP_CurrentTree.MenuWidth - NPMIP_BorderWidth);
				pixelLeft = (this.index * (NPMIP_CurrentTree.MenuWidth - NPMIP_BorderWidth));
				var LeftAndWidth = pixelLeft + pixelWidth;
				this.menu.style.pixelWidth = LeftAndWidth + (NPMIP_BorderWidth * 2);
			}
		}
		else {
			pixelLeft = 0;
		}
	}
}

function NPMIP_f_FixSize(makevis){
	if(this.isHorizontal) {
		var MaxItemHeight = 0;
	    for(i=0; i<this.items.length; i++) {
	        var TempItem = this.items[i];
		    if (TempItem.index) {
				var SiblingHeight = TempItem.siblingBelow.scrollHeight;
				MaxItemHeight = Math.max(MaxItemHeight,SiblingHeight);
			}
	       	else{
				MaxItemHeight = TempItem.scrollHeight;
			}
		}
	    for(i=0; i<this.items.length; i++) {
	        var TempItem = this.items[i];
			TempItem.style.pixelHeight = MaxItemHeight;
			if(TempItem.imgLyr) {
				if(this.tree.RightToLeft){
					TempItem.imgLyr.style.pixelLeft = (NPMIP_ItemPadding + NPMIP_ImageHorizSpace);
				}
				else {
					TempItem.imgLyr.style.pixelLeft = TempItem.style.pixelWidth - ((TempItem.isLastItem ? 0 : NPMIP_SeparatorSize) + NPMIP_ItemPadding + NPMIP_ImageHorizSpace + NPMIP_ImageSize);
				}
			}
		}
		this.style.pixelHeight = MaxItemHeight + (NPMIP_BorderWidth * 2);
	}
	else {
		if(this.IsVariableWidth) {
			var MaxItemWidth = 0;
	    	for(i=0; i<this.items.length; i++) {
	        	var TempItem = this.items[i];
				TempItem.style.pixelWidth = TempItem.scrollWidth;
				MaxItemWidth = i ? Math.max(MaxItemWidth,TempItem.style.pixelWidth) : TempItem.style.pixelWidth;
			}
	    	for(i=0; i<this.items.length; i++) {
				this.items[i].style.pixelWidth = MaxItemWidth;
			}
			this.style.pixelWidth = MaxItemWidth + (NPMIP_BorderWidth * 2);
		}
	    for(i=0; i<this.items.length; i++) {
	        var TempItem = this.items[i];
		    if (TempItem.index) {
				var SiblingHeight =(TempItem.siblingBelow.scrollHeight + NPMIP_SeparatorSize);
				TempItem.style.pixelTop = TempItem.siblingBelow.style.pixelTop + SiblingHeight;
			}
			else TempItem.style.pixelTop = 0;
			if(TempItem.imgLyr) {
				if(NPMIP_CurrentTree.RightToLeft){
					TempItem.imgLyr.style.pixelLeft = (NPMIP_ItemPadding + NPMIP_ImageHorizSpace);
				}
				else {
					TempItem.imgLyr.style.pixelLeft = TempItem.style.pixelWidth - (NPMIP_ItemPadding + NPMIP_ImageHorizSpace + NPMIP_ImageSize);
				}
			}
		}
		this.style.pixelHeight = TempItem.style.pixelTop + TempItem.scrollHeight + (NPMIP_BorderWidth * 2);
	}
	this.sizeFixed = true;
	if(makevis)this.style.visibility = "visible";
}

function NPMIP_f_ItemSetup(whichItem) {
    this.menu = this.parentElement;
	this.ClickStart = this.hasMore && this.tree.ClickStart && (this.tree.TopIsPermanent && (this.tree.treeParent==this.menu));
	if(this.ClickStart) {
		this.linkText = "";
		this.onclick = this.showChild;
	}

    if (this.hasMore) {
		if(this.menu.showImage){
			this.imgLyr = this.children("NPMIP_ImMore");
			this.hasImageRollover = ((!this.tree.RightToLeft && NPMIP_ImageSrcOver) || (this.tree.RightToLeft && NPMIP_ImageSrcLeftOver));
			if(this.hasImageRollover) {
				this.imageSrc = this.tree.RightToLeft ? NPMIP_ImageSrcLeft : NPMIP_ImageSrc;
				this.imageSrcOver = this.tree.RightToLeft ? NPMIP_ImageSrcLeftOver : NPMIP_ImageSrcOver;
				if(this.permHilite) this.imgLyr.src = this.imageSrcOver;
			}
		}

        this.child = document.all(this.childID);
        if(this.child) {
			this.child.parentMenu = this.menu;
        	this.child.parentItem = this;
		}
    }
	if(this.linkText && !this.ClickStart) {
		this.onclick = NPMIP_f_LinkIt;
		if(NPMIP_ShowLinkCursor)this.style.cursor = "hand";
	}

	this.setItemStyle();
}

function setLinkAndGo(menuname, link)
{
	if(NPMIP_Link != null) NPMIP_Link = null;
	NPMIP_Link = link;
	NPMIP_f_PopUp(menuname);
}

function NPMIP_f_PopUp(menuname){
    if (!NPMIP_AreLoaded) return;
	menuname = menuname.replace("elMenu",NPMIP_MenuIDPrefix);
	var TempMenu = document.all(menuname);
	if(!TempMenu) return;
	NPMIP_CurrentMenu = TempMenu;
	if (NPMIP_CurrentMenu.tree.ClickStart) {
		var ClickElement = event.srcElement;
		ClickElement.onclick = NPMIP_f_PopMenu;
    }
	else NPMIP_f_PopMenu();
}

function NPMIP_f_PopMenu(){
    if (!NPMIP_AreLoaded || !NPMIP_AreCreated) return true;
    if (NPMIP_CurrentMenu.tree.ClickStart && event.type != "click") return true;
	var mouse_x_position, mouse_y_position;
    NPMIP_f_HideAll();
    NPMIP_CurrentMenu.hasParent = false;
	NPMIP_CurrentMenu.tree.startChild = NPMIP_CurrentMenu;
	NPMIP_CurrentMenu.mouseX = mouse_x_position = (event.clientX + document.body.scrollLeft);
	NPMIP_CurrentMenu.mouseY = mouse_y_position = (event.clientY + document.body.scrollTop);
	NPMIP_CurrentMenu.xIntended = NPMIP_CurrentMenu.xPos = (NPMIP_CurrentMenu.tree.MenuLeft!=null) ? eval(NPMIP_CurrentMenu.tree.MenuLeft) : mouse_x_position;
	NPMIP_CurrentMenu.yIntended = NPMIP_CurrentMenu.yPos = (NPMIP_CurrentMenu.tree.MenuTop!=null)  ? eval(NPMIP_CurrentMenu.tree.MenuTop)  : mouse_y_position;
	if(!NPMIP_CurrentMenu.sizeFixed) NPMIP_CurrentMenu.fixSize(false);
    NPMIP_CurrentMenu.keepInWindow();
    NPMIP_CurrentMenu.moveTo(NPMIP_CurrentMenu.xPos,NPMIP_CurrentMenu.yPos);
    NPMIP_CurrentMenu.isOn = true;
    NPMIP_CurrentMenu.showIt(true);
    return false;
}

function NPMIP_f_MenuOver() {
	if(!this.tree.startChild){this.tree.startChild = this}
	if(this.tree.startChild == this) NPMIP_f_HideAll(this)
    this.isOn = true;
    NPMIP_UserOverMenu = true;
    NPMIP_CurrentMenu = this;
    if (this.hideTimer) clearTimeout(this.hideTimer);
}

function NPMIP_f_MenuOut() {
	if(event.srcElement.contains(event.toElement)) return;
    this.isOn = false;
    NPMIP_UserOverMenu = false;
    if(NPMIP_StatusDisplayLink) status = "";
	if(!NPMIP_ClickKill) {
		clearTimeout(NPMIP_HideAllTimer);
		NPMIP_HideAllTimer = null;
		NPMIP_HideAllTimer = setTimeout("NPMIP_CurrentMenu.hideTree()",NPMIP_ChildMilliSecondsVisible);
	}
}

function NPMIP_f_ShowChild(){
	if(!this.child) {
		NPMIP_CurrentTree = this.tree;
		NPMIP_CurrentMenu = this.menu;
		NPMIP_CurrentItem = this;
		this.child = NPMIP_f_MakeMenu(this.menu.count + "_"+(this.index+1));
		this.tree.treeParent = this.menu;
		this.tree.startChild = this.menu;
       	this.child.parentItem = this;
	}

	if(!this.child.sizeFixed) this.child.fixSize(false);

	if (this.tree.PositionUnder && (this.menu == this.tree.treeParent)) {
		this.child.xPos = this.menu.style.pixelLeft + this.style.pixelLeft;
		this.child.yPos = this.menu.style.pixelTop + this.menu.offsetHeight - (NPMIP_BorderWidth);
	}
	else {
		if(this.ChildOverlap==null) {
			this.DistanceToRightEdge = this.style.pixelWidth;
			if (!this.menu.isHorizontal || (this.menu.isHorizontal && this.isLastItem)) this.DistanceToRightEdge += NPMIP_BorderWidth;
			this.DistanceToLeftEdge = (!this.menu.isHorizontal || (this.menu.isHorizontal && this.index==0)) ? NPMIP_BorderWidth : NPMIP_SeparatorSize;
			this.ChildOverlap = (parseInt((NPMIP_ChildPerCentOver != null) ? (NPMIP_ChildPerCentOver  * this.DistanceToRightEdge) : NPMIP_ChildOverlap));
		}

		this.oL = this.menu.style.pixelLeft + this.offsetLeft + NPMIP_BorderWidth;
		this.oT = this.menu.style.pixelTop  + this.offsetTop;
		if(this.tree.RightToLeft) {
			this.child.xPos = ((this.oL - this.DistanceToLeftEdge) + this.ChildOverlap) - this.child.style.pixelWidth;
		}
		else {		
			this.child.xPos = (this.oL + this.DistanceToRightEdge) - this.ChildOverlap;
		}
		this.child.yPos = this.oT + NPMIP_ChildOffset + NPMIP_BorderWidth;
	}
	this.child.xDiff = this.child.xPos - this.menu.style.pixelLeft;
	this.child.yDiff = this.child.yPos - this.menu.style.pixelTop;
	if(!this.tree.PositionUnder || this.menu!=this.tree.treeParent) this.child.keepInWindow();
	this.child.moveTo(this.child.xPos,this.child.yPos);
	this.menu.hasChildVisible = true;
	this.menu.visibleChild = this.child;
	this.child.showIt(true);
}

function NPMIP_f_ItemOver(){
    if (NPMIP_KeepHilite) {
        if (this.menu.currentItem && this.menu.currentItem != this && this.menu.currentItem.hasRollover) {
            with(this.menu.currentItem.style){
				backgroundColor = this.tree.BGColor;
            	color = this.tree.FontColor
			}
			if(this.menu.currentItem.hasImageRollover)this.menu.currentItem.imgLyr.src = this.menu.currentItem.imageSrc;
        }
    }
	if(event.srcElement.id == "NPMIP_ImMore") return;
	if(this.hasRollover) {
		this.style.backgroundColor = this.tree.BGColorOver;
		this.style.color = this.tree.FontColorOver;
		if(this.hasImageRollover)this.imgLyr.src = this.imageSrcOver;
	}
    if(NPMIP_StatusDisplayLink) status = this.linkText;
    this.menu.currentItem = this;
	if (this.menu.hasChildVisible) {
		if(this.menu.visibleChild == this.child && this.menu.visibleChild.hasChildVisible) this.menu.visibleChild.hideChildren(this);
		else this.menu.hideChildren(this);
    }
    if (this.hasMore && !this.ClickStart) this.showChild();
}

function NPMIP_f_ItemOut() {
	if (event.srcElement.contains(event.toElement)
	  || (event.fromElement.tagName=="IMG" && (event.toElement && event.toElement.contains(event.fromElement))))
		  return;
    if ( (!NPMIP_KeepHilite || ((this.tree.TopIsPermanent && (this.tree.treeParent==this)) && !this.menu.hasChildVisible)) && this.hasRollover) {
		with(this.style) {
			backgroundColor = this.tree.BGColor;
			color = this.tree.FontColor
		}
		if(this.hasImageRollover)this.imgLyr.src = this.imageSrc;

    }
}

function NPMIP_f_MoveTo(xPos,yPos) {
	this.style.pixelLeft = xPos;
	this.style.pixelTop = yPos;
}

function NPMIP_f_ShowIt(on) {
	if (!(this.tree.TopIsPermanent && (this.tree.treeParent==this))) {
		if(!this.hasParent || (this.hasParent && this.tree.TopIsPermanent && (this.tree.treeParent==this.parentMenu))) {
			var IsVisible = (this.style.visibility == "visible");
			if ((on && !IsVisible) || (!on && IsVisible))
				eval(on ? this.tree.UponDisplay : this.tree.UponHide)
		}
		if (on) 
		{
			this.style.zIndex = ++NPMIP_ZIndex;
			
			if(NPMIP_Link != null) 
			{
				if( (NPMIP_Link.indexOf("ConnectExpert") != -1 && this.dispText.indexOf("Connect Expert") != -1) || (NPMIP_Link.indexOf("ConnectExpert") == -1 && this.dispText.indexOf("Connect Expert") == -1))
				{
					this.linkText = NPMIP_Link;
					this.onclick = NPMIP_f_LinkIt;
					if(NPMIP_ShowLinkCursor) this.style.cursor = "hand";
				}
			}
		}
		this.style.visibility = (on) ? "visible" : "hidden";
	}
    if (NPMIP_KeepHilite && this.currentItem && this.currentItem.hasRollover) {
		with(this.currentItem.style){
			backgroundColor = this.tree.BGColor;
			color = this.tree.FontColor;
		}
		if(this.currentItem.hasImageRollover)this.currentItem.imgLyr.src = this.currentItem.imageSrc;
    }
    this.currentItem = null;
}

function NPMIP_f_KeepInWindow() {
    var ExtraSpace     = 10;
	var WindowLeftEdge = document.body.scrollLeft;
	var WindowTopEdge  = document.body.scrollTop;
	var WindowWidth    = document.body.clientWidth;
	var WindowHeight   = document.body.clientHeight;
	var WindowRightEdge  = (WindowLeftEdge + WindowWidth) - ExtraSpace;
	var WindowBottomEdge = (WindowTopEdge + WindowHeight) - ExtraSpace;

	var MenuLeftEdge = this.xPos;
	var MenuRightEdge = MenuLeftEdge + this.style.pixelWidth;
	var MenuBottomEdge = this.yPos + this.style.pixelHeight;

	if (this.hasParent) {
		var ParentLeftEdge = this.parentItem.oL;
	}
	if (MenuRightEdge > WindowRightEdge) {
		if (this.hasParent) {
			this.xPos = ((ParentLeftEdge - this.parentItem.DistanceToLeftEdge) + this.parentItem.ChildOverlap) - this.offsetWidth;
		}
		else {
			dif = MenuRightEdge - WindowRightEdge;
			this.xPos -= dif;
		}
		this.xPos = Math.max(5,this.xPos);
	}

	if (MenuBottomEdge > WindowBottomEdge) {
		dif = MenuBottomEdge - WindowBottomEdge;
		this.yPos -= dif;
	}

	if (MenuLeftEdge < WindowLeftEdge) {
		if (this.hasParent) {
			this.xPos = (ParentLeftEdge + this.parentItem.DistanceToRightEdge) - this.parentItem.ChildOverlap;
			MenuRightEdge = this.xPos + this.style.pixelWidth;
			if(MenuRightEdge > WindowRightEdge) this.xPos -= (MenuRightEdge - WindowRightEdge);
		}
		else {this.xPos = 5}
	}
}

function NPMIP_f_LinkIt() {
    if (this.linkText.indexOf("javascript:")!=-1) eval(this.linkText)
    else 
    {
		NPMIP_f_HideAll();
		location.href = this.linkText;
    }
    NPMIP_Link = null;
}

function NPMIP_f_PopDown(menuname){
    if (!NPMIP_AreLoaded || !NPMIP_AreCreated) return;
	menuname = menuname.replace("elMenu",NPMIP_MenuIDPrefix);
    var MenuToHide = document.all(menuname);
	if(!MenuToHide)return;
    MenuToHide.isOn = false;
    if (!NPMIP_ClickKill) MenuToHide.hideTop();
}

function NPMIP_f_HideAll(callingmenu) {
	for(var i=0; i<NPMIP_TotalTrees; i++) {
        var TopMenu = NPMIP_a_TopMenus[i].tree.startChild;
		if(TopMenu == callingmenu)continue
        TopMenu.isOn = false;
        if (TopMenu.hasChildVisible) TopMenu.hideChildren();
        TopMenu.showIt(false);
    }    
}

function NPMIP_f_HideTree() { 
    NPMIP_HideAllTimer = null;
    if (NPMIP_UserOverMenu) return;
    if (this.hasChildVisible) this.hideChildren();
    this.hideParents();
}

function NPMIP_f_HideTop() {
	TopMenuToHide = this;
    (NPMIP_ClickKill) ? TopMenuToHide.hideSelf() : (this.hideTimer = setTimeout("TopMenuToHide.hideSelf()",NPMIP_TopMilliSecondsVisible));
}

function NPMIP_f_HideSelf() {
    this.hideTimer = null;
    if (!this.isOn && !NPMIP_UserOverMenu) this.showIt(false);
}

function NPMIP_f_HideParents() {
    var TempMenu = this;
    while(TempMenu.hasParent) {
        TempMenu.showIt(false);
        TempMenu.parentMenu.isOn = false;        
        TempMenu = TempMenu.parentMenu;
    }
    TempMenu.hideTop();
}

function NPMIP_f_HideChildren(callingitem) {
    var TempMenu = this.visibleChild;
    while(TempMenu.hasChildVisible) {
        TempMenu.visibleChild.showIt(false);
        TempMenu.hasChildVisible = false;
        TempMenu = TempMenu.visibleChild;
    }
	if((callingitem && (!callingitem.hasMore || this.visibleChild != callingitem.child)) || (!callingitem && !this.isOn)) {
		this.visibleChild.showIt(false);
		this.hasChildVisible = false;
	}
}

function NPMIP_f_CancelSelect(){return false}

function NPMIP_f_PageClick() {
    if (!NPMIP_UserOverMenu && NPMIP_CurrentMenu!=null && !NPMIP_CurrentMenu.isOn) NPMIP_f_HideAll();
}

popUp = NPMIP_f_PopUp;
popDown = NPMIP_f_PopDown;

function NPMIP_f_ResizeHandler(){
	var mouse_x_position, mouse_y_position;
	for(var i=0; i<NPMIP_TotalTrees; i++) {
        var TopMenu = NPMIP_a_TopMenus[i].tree.startChild;
		if(TopMenu.style.visibility == "visible") {
			TopMenu.oldLeft = TopMenu.xPos;
			TopMenu.oldTop = TopMenu.yPos;
			mouse_x_position = TopMenu.mouseX;
			mouse_y_position = TopMenu.mouseY;
			TopMenu.xPos = eval(TopMenu.tree.MenuLeft);
			TopMenu.yPos = eval(TopMenu.tree.MenuTop);
			if(TopMenu.xPos == null) TopMenu.xPos = TopMenu.xIntended;
			if(TopMenu.yPos == null) TopMenu.yPos = TopMenu.yIntended;
			if(!TopMenu.tree.TopIsPermanent) TopMenu.keepInWindow();
			TopMenu.moveTo(TopMenu.xPos,TopMenu.yPos);
			var TempMenu = TopMenu;
		    while(TempMenu.hasChildVisible) {
				TempParent = TempMenu;
				TempMenu = TempMenu.visibleChild;
				TempMenu.xPos = TempParent.xPos + TempMenu.xDiff;
				TempMenu.yPos = TempParent.yPos + TempMenu.yDiff;
				if(!TopMenu.tree.TopIsPermanent || (TopMenu.tree.TopIsPermanent && !TopMenu.tree.PositionUnder)) TempMenu.keepInWindow();
				TempMenu.moveTo(TempMenu.xPos,TempMenu.yPos);
		    }
		}
    }
	NPMIP_f_OtherResize();
}

NPMIP_f_OtherResize = (window.onresize) ? window.onresize :  new Function;
window.onresize = NPMIP_f_ResizeHandler;

NPMIP_f_OtherOnLoad = (window.onload) ? window.onload :  new Function;
window.onload = function(){setTimeout("NPMIP_f_StartIt()",10)};

//end