clear
echo "This program will install NV4IP V1.5 on your computer and will"
echo "install and configure your Apache Web Server and Apache Tomcat"
echo "environments. You must be logged on as root to install NV4IP 1.5"
echo ""
echo "***************************************************************"
echo "********                  IMPORTANT                    ********"
echo "***************************************************************"
echo "* This program should be run only after you have successfully *"
echo "* have installed the following components:                    *"
echo "*                                                             *"
echo "* 1.  Sun Java SDK 1.3.1_04                                   *"
echo "* NOTE - older versions of Java are not compatible            *"
echo "*                                                             *"
echo "* It will copy the necessary web files, servlets, and jsps to *"
echo "* your computer.                                              *"
echo "*                                                             *"
echo "* DO NOT PROCEED UNTIL YOU HAVE INSTALLED THE ABOVE COMPONENTS*"
echo "*                                                             *"
echo "* By default, Apache Web Server will be installed in          *"
echo "* APACHE_HOME=/usr/local/apache                               *"
echo "*                                                             *"
echo "* By default, Apache Tomcat will be installed in              *"
echo "* TOMCAT_HOME=/usr/local/jakarta-tomcat                       *"
echo "*                                                             *"
echo "* By default, your CDROM mount point is assumed to be         *"
echo "* CDMNTPT=/mnt/cdrom                                          *"
echo "*                                                             *"
echo "* If you wish to change any of the default settings, please   *"      
echo "* edit the setup.sh file.                                     *"
echo "***************************************************************"

INSTALL_HOME=$PWD
INSTALL_ROOT=/usr/local
APACHE_HOME=$INSTALL_ROOT/apache
TOMCAT_HOME=$INSTALL_ROOT/jakarta-tomcat
PJA_HOME=$INSTALL_ROOT/pja_2.4
CDMNTPT=/mnt/cdrom

# Prompt for IP ADDRESS
echo "1. Enter IP Address. This is the server IP. IE 123.23.41.122"
read IP

# Prompt for Java Directory
echo "2. Enter in the value of JAVA_HOME IE /usr/local/jdk1.3.1_04"
read JAVA_HOME

cp $CDMNTPT/linux/* $INSTALL_HOME
mkdir $APACHE_HOME
mkdir $TOMCAT_HOME
mkdir $PJA_HOME

gunzip apache_1.3.26-i686-whatever-linux22.tar.gz 
tar -xvf apache_1.3.26-i686-whatever-linux22.tar

gunzip jakarta-tomcat-4.0.4.tar.gz
tar -xvf jakarta-tomcat-4.0.4.tar

# Install Apache 1.3.26
cd apache_1.3.26 
cp -r bindist/* $APACHE_HOME

# Install Tomcat 4.0.4
cd $INSTALL_HOME
cp -fr jakarta-tomcat-4.0.4/* $TOMCAT_HOME

echo "."
# Install mod_jk.so Apache-Tomcat Connector
cp $INSTALL_HOME/mod_jk.so $APACHE_HOME/libexec

echo "."
# Edit apachectl startup script
cd $APACHE_HOME/bin
head -n 23 apachectl > temp
echo "PIDFILE=$APACHE_HOME/logs/httpd.pid" >> temp
echo "HTTPD=$APACHE_HOME/bin/httpd" >> temp
tail -n 204 apachectl >> temp
rm -fr apachectl
mv temp apachectl
chmod a+xw apachectl

echo "."
# Edit httpd.conf
cd $APACHE_HOME/conf
head -343 httpd.conf > temp
echo "ServerName $IP" >> temp
tail -715 httpd.conf >> temp
echo "Include $TOMCAT_HOME/conf/nvip/nvip_mod_jk.conf" >> temp
rm -fr httpd.conf
mv temp httpd.conf

echo "."
# Create and copy nvip_mod_jk.conf and nvip_worker.properties
cd $INSTALL_HOME
mkdir $TOMCAT_HOME/conf/nvip

head -n 3 nvip_mod_jk.conf > temp
echo "JkWorkersFile \"$TOMCAT_HOME/conf/nvip/nvip_workers.properties\"" >> temp
tail -n 9 nvip_mod_jk.conf >> temp
rm -f nvip_mod_jk.conf 
mv temp nvip_mod_jk.conf

echo "."
cp $INSTALL_HOME/nvip_mod_jk.conf $TOMCAT_HOME/conf/nvip

head -n 5 nvip_workers.properties > temp
echo "worker.ajp13.host=$IP" >> temp
tail -n 1 nvip_workers.properties >> temp

echo "."
rm -f nvip_workers.properties
mv temp nvip_workers.properties
cp $INSTALL_HOME/nvip_workers.properties $TOMCAT_HOME/conf/nvip

# Edit JAVA_OPTS variable in startup.sh
cd $TOMCAT_HOME/bin

echo "."
echo "export JAVA_OPTS=\"-Xbootclasspath/a:$PJA_HOME/pja.jar -Djava.awt.fonts=/usr/share/fonts/default/TrueType -Duser.home=$JAVA_HOME/jre\"" > ctemp
echo "export CLASSPATH=\"$PJA_HOME:$CLASSPATH\"" >> ctemp
cat startup.sh >> ctemp
rm -f startup.sh
mv ctemp startup.sh
chmod a+x startup.sh

# Install NVIP
cp $CDMNTPT/nvip.war $TOMCAT_HOME/webapps
cp -r $CDMNTPT/htdocs/nvip $APACHE_HOME/htdocs/
cp $CDMNTPT/pja*.jar $PJA_HOME
cd $PJA_HOME
chmod a+x *

echo "."
# Cleanup
cd $INSTALL_HOME
rm -fr apache_1.3.26
rm -fr jakarta-tomcat-4.0.4
rm -fr apache_1.3.26*.tar
rm -fr jakarta-tomcat-4.0.4.tar
rm -fr mod_jk.so
 
echo "***************************************************************"
echo "*                                                             "
echo "*    Please set the following environment variables           "
echo "*    1. APACHE_HOME=$APACHE_HOME                              "
echo "*    2. TOMCAT_HOME=$TOMCAT_HOME                              "
echo "*    3. JAVA_HOME=$JAVA_HOME                                  "
echo "*    4. PATH=\$PATH:$JAVA_HOME/bin                            "
echo "*                                                             "
echo "*    To start Tomcat server                                   "
echo "*    TOMCAT_HOME/bin/startup.sh                               "
echo "*    To stop Tomcat server                                    "
echo "*    TOMCAT_HOME/bin/shutdown.sh                              "
echo "*                                                             "
echo "*    To start Apache Httpd server                             "
echo "*    APACHE_HOME/bin/apachectl start                          "
echo "*    To stop Apache Httpd server                              "
echo "*    APACHE_HOME/bin/apachectl stop                           "
echo "*                                                             "
echo "***************************************************************"

